// SocketSwitch.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SocketSwitch.h"
#include "Winsock2.h"
#include "stdio.h"
#include <shellapi.h>

#define MAX_LOADSTRING 100
#define WM_APP_NOTIFYICON       (WM_APP + 0x01)
#define SELECT_CYCLES           (3)
#define CONNECT_CYCLES          (3)
#define SELECT_TIME_SECS        (5)
#define SELECT_TIME_USECS       (0)

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
static char gszDisplay[4][1024] = {"" ,"", "", ""};
void Redraw (PAINTSTRUCT * psPaint, HDC sHDC);
void Resize (WPARAM wparam, LPARAM lparam);

typedef struct _SendRec
{
  SOCKET  sReceive;
  int     nReceivePort;
  char    *szReceiveAddr;
  SOCKET  sSend;
  int     nSendPort;
  char    *szSendAddr;
} SendRec;

static int          gboListen = false;
static int          gboConnect;
static int          gnSockTypeIn = SOCK_STREAM;
//static int          gnPortIn = 6435;
static int          gnPortIn = 6436;
static int          gnSockTypeOut = SOCK_STREAM;
static int          gnPortOut = 3389;
static char         gszAddressOut[1024] = "127.0.0.1";
static char         gszAddressIn[1024] = "127.0.0.1";
static HANDLE       ghListenHandle = 0;
static HWND         ghWnd = 0;
static WSAData      gsWSAData;
static bool         gboClosed;
static SendRec      gsSendRecIn;
static SendRec      gsSendRecOut;
static HMENU        ghIconMenu;
static bool         gboTrayActive;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Details(HWND, UINT, WPARAM, LPARAM);
void listenProc(void);
void Quit (void);
void Connect (bool boConnect);
void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick);
void SendRecProc (SendRec * psSendRec);
void SetScreenText (char * szText, int nPos);
void ShowError (void);
void CloseSocket (SOCKET nSocket);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
  int nArgPos;
  int nStartPos;
  int nCopyPos;
  char szInput[1024];
  int nArg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SOCKETSWITCH, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

  if (lpCmdLine)
  {
    nArg = 0;
    nArgPos = 0;
    while (lpCmdLine[nArgPos] >= 32)
    {
      // Remove any spaces
      while (lpCmdLine[nArgPos] == 32)
      {
        nArgPos++;
      }

      // First input Address in
      nStartPos = nArgPos;
      nCopyPos = 0;
      while ((lpCmdLine[nArgPos] > 32) && (lpCmdLine[nArgPos] != ':'))
      {
        if (nCopyPos < (sizeof (szInput) - 1))
        {
          szInput[nCopyPos] = lpCmdLine[nArgPos];
          nCopyPos++;
        }
        nArgPos++;
      }
      szInput[nCopyPos] = 0;

      switch (nArg)
      {
        case 0: // Send to address
          strcpy (gszAddressOut, szInput);
          if (lpCmdLine[nArgPos] != ':')
          {
            nArg++;
          }
          else
          {
            nArgPos++;
          }
          break;
        case 1: // Send to port
          sscanf (szInput, "%d", & gnPortOut);
          break;
        case 2: // Send to address
          strcpy (gszAddressIn, szInput);
          if (lpCmdLine[nArgPos] != ':')
          {
            nArg++;
          }
          else
          {
            nArgPos++;
          }
          break;
        case 3: // Send to port
          sscanf (szInput, "%d", & gnPortIn);
          break;
      }
      nArg++;
    }
  }

  gboListen = false;
  gboConnect = false;

  Connect (false);
  Connect (true);

  Resize (SIZE_MINIMIZED, 0);

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SOCKETSWITCH);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SOCKETSWITCH);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_SOCKETSWITCH;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  HWND hWnd;

  hInst = hInstance; // Store instance handle in our global variable

  hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, 0, 180, 100, NULL, NULL, hInstance, NULL);

  if (!hWnd)
  {
    return FALSE;
  }

  ghWnd = hWnd;
  if (WSAStartup (MAKEWORD (1, 1), & gsWSAData) != 0)
  {
  	MessageBox (ghWnd, "Error starting WinSock", "Socket error", MB_OK);
	  return 0;
  }

  gboTrayActive = FALSE;
  SetScreenText ("Started", 0);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  Connect (false);

  return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int                 wmId;
	int                 wmEvent;
	PAINTSTRUCT         ps;
	HDC                 hdc;
	UINT                uID; 
	UINT                uMouseMsg;
	HMENU               hPopUpMenu;
	POINT               sPoint;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox (hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			Quit ();
			break;
	  case ID_CONNECT_CONNECT:
	    Connect (!gboConnect);
	    break;
	  case IDM_DETAILS:
			DialogBox (hInst, (LPCTSTR)IDD_DETAILS, hWnd, (DLGPROC)Details);
	    break;
		case ID_MENU_SHOW:
			ShowWindow (ghWnd, SW_RESTORE);
			SetForegroundWindow (ghWnd);
			break;
			return true;
		case ID_MENU_ABOUT:
			DialogBoxParam(hInst, (LPCTSTR) IDD_ABOUTBOX, ghWnd, (DLGPROC)About, (LPARAM)About);
			break;
			return true;
		case ID_MENU_EXIT:
			DestroyWindow(hWnd);
			Quit ();
			break;
			return true;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
    Redraw (& ps, hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
    Quit ();
		PostQuitMessage(0);
		break;
	case WM_SIZE:
		Resize (wParam, lParam);
		break;

	case WM_APP_NOTIFYICON:
		uID = (UINT) wParam; 
		uMouseMsg = (UINT) lParam; 

		switch (uMouseMsg)
		{
			case WM_LBUTTONDOWN:
				if (uID ==  1)
				{
					if (!ghWnd)
					{
						ShowWindow (ghWnd, SW_RESTORE);
						SetForegroundWindow (ghWnd);
					}
					else
					{
						if (IsIconic (ghWnd))
						{
							ShowWindow (ghWnd, SW_RESTORE);
							SetForegroundWindow (ghWnd);
						}
						else
						{
							ShowWindow (ghWnd, SW_RESTORE);
							SetForegroundWindow (ghWnd);
						}
					}
				}
			break;
			return true;
			case WM_RBUTTONDOWN:
				SetForegroundWindow (ghWnd);
				GetCursorPos (& sPoint);
				hPopUpMenu = GetSubMenu(ghIconMenu, 0);
				SetMenuDefaultItem (hPopUpMenu, ID_MENU_SHOW, FALSE);
				TrackPopupMenuEx (hPopUpMenu, (TPM_RIGHTALIGN | TPM_BOTTOMALIGN | TPM_RIGHTBUTTON | TPM_HORIZONTAL),
				sPoint.x, sPoint.y, ghWnd, NULL);
			break;
			return true;
		}
		break;





	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

void Resize (WPARAM wparam, LPARAM lparam)
{
	NOTIFYICONDATA      sIconData;
	HICON               hTrayIcon;
	char                szTip[100] = "Beacon";

	if (wparam == SIZE_MINIMIZED)
	{
		// minimize to tray
		ghIconMenu = NULL;
		gboTrayActive = true;

		hTrayIcon = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON));

		sIconData.cbSize = sizeof (NOTIFYICONDATA);
		sIconData.hWnd = ghWnd;
		sIconData.uID = 1;
		sIconData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		sIconData.uCallbackMessage = WM_APP_NOTIFYICON;
		sIconData.hIcon = hTrayIcon;
		strncpy (sIconData.szTip, szTip, 64);
		Shell_NotifyIcon (NIM_ADD, & sIconData);
		ghIconMenu = LoadMenu (hInst, MAKEINTRESOURCE(IDR_ICON));
		if (hTrayIcon)
		{
			DestroyIcon (hTrayIcon);
		}
		// remove from taskbar
		ShowWindow(ghWnd, SW_HIDE);
		//SetWindowLongPtr(hwnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW);
	}

	if ((wparam == SIZE_RESTORED) && (gboTrayActive))
	{
		// remove tray icon
		gboTrayActive = false;
		sIconData.hWnd = ghWnd;
		sIconData.uID = 1;
		sIconData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		sIconData.uCallbackMessage = WM_APP_NOTIFYICON;
		sIconData.hIcon = NULL;
		Shell_NotifyIcon (NIM_DELETE, & sIconData);
		// reshow taskbar entry
		//SetWindowLongPtr(hwnd, GWL_EXSTYLE, NULL);
	}
}

void Redraw (PAINTSTRUCT * psPaint, HDC sHDC)
{
	COLORREF        uPrevFore;
	COLORREF        uPrevBack;
	HFONT           sPrevFont;
	HFONT           sFont;
	LOGFONT         sFontInfo;

	uPrevFore = SetTextColor (sHDC, RGB(0x00, 0x00, 0x00));
	uPrevBack = SetBkColor (sHDC, RGB(0xff, 0xff, 0xff));

	memset (& sFontInfo, 0, sizeof (LOGFONT));
	sFontInfo.lfHeight = 16;
	strcpy (sFontInfo.lfFaceName, "Courier New");
	sFont = ::CreateFontIndirect (& sFontInfo);
	sPrevFont = (HFONT)::SelectObject (sHDC, sFont);

	// Font and colours set up, so now do the plotting

	SetTextColor (sHDC, RGB(0,0,0));
	ExtTextOut(sHDC, 5, 0, 0, NULL, gszDisplay[0], (int)strlen (gszDisplay[0]), NULL);
	ExtTextOut(sHDC, 5, 16, 0, NULL, gszDisplay[1], (int)strlen (gszDisplay[1]), NULL);
	ExtTextOut(sHDC, 5, 32, 0, NULL, gszDisplay[2], (int)strlen (gszDisplay[2]), NULL);
	ExtTextOut(sHDC, 5, 48, 0, NULL, gszDisplay[3], (int)strlen (gszDisplay[3]), NULL);

	::SelectObject (sHDC, sPrevFont);
	DeleteObject (sFont);
	SetTextColor (sHDC, uPrevFore);
	SetBkColor (sHDC, uPrevBack);
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// Message handler for details box.
LRESULT CALLBACK Details(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  char szText[1024];
	HWND hCombo;
	HWND hItem;
  int nSel;

	switch (message)
	{
	case WM_INITDIALOG:
    SetDlgItemText (hDlg, IDC_SENDIP, gszAddressOut);
    sprintf (szText, "%d", gnPortOut);
    SetDlgItemText (hDlg, IDC_SENDPORT, szText);
		hCombo = GetDlgItem (hDlg, IDC_SENDTYPE);
//    sprintf (szText, "TCP");
//		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
//    sprintf (szText, "UDP");
//		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
//		SendMessage (hCombo, (UINT)CB_SETCURSEL, (WPARAM)(gnSockTypeOut - 1), 0);


    SetDlgItemText (hDlg, IDC_RECEIVEIP, gszAddressIn);
    sprintf (szText, "%d", gnPortIn);
    SetDlgItemText (hDlg, IDC_RECEIVEPORT, szText);
		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
//    sprintf (szText, "TCP");
//		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
//    sprintf (szText, "UDP");
//		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
//		SendMessage (hCombo, (UINT)CB_SETCURSEL, (WPARAM)(gnSockTypeIn - 1), 0);
//    hItem = GetDlgItem (hDlg, IDC_RECEIVEIP);
//    EnableWindow (hItem, (gnSockTypeIn == 2));
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK)
		{
		  GetDlgItemText (hDlg, IDC_SENDIP, gszAddressOut, sizeof (gszAddressOut));
		  GetDlgItemText (hDlg, IDC_SENDPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortOut);
  		hCombo = GetDlgItem (hDlg, IDC_SENDTYPE);
  		gnSockTypeOut = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;

		  GetDlgItemText (hDlg, IDC_RECEIVEIP, gszAddressIn, sizeof (gszAddressIn));
		  GetDlgItemText (hDlg, IDC_RECEIVEPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortIn);
  		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
  		gnSockTypeIn = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;
		}

		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}

    if (HIWORD(wParam) == CBN_SELCHANGE)
    {
  		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
  		nSel = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;

      hItem = GetDlgItem (hDlg, IDC_RECEIVEIP);
      EnableWindow (hItem, (nSel == 2));
		  return TRUE;
    }
		break;
	}
	return FALSE;
}

void Quit (void)
{
  NOTIFYICONDATA sIconData;

	// Clean up taskbar icon
	if (gboTrayActive)
	{
		sIconData.cbSize = sizeof (NOTIFYICONDATA);
		sIconData.hWnd = ghWnd;
		sIconData.uID = 1;
		sIconData.uFlags = 0;
		Shell_NotifyIcon (NIM_DELETE, & sIconData);
		DestroyMenu (ghIconMenu);
	}
	WSACleanup();
}

void listenProc(void)
{
	SOCKET              nSockfdIn;
	SOCKET              nSockfdOut;
	struct sockaddr_in  sHostAddr;
	struct sockaddr_in  sClientAddr;
	int                 nReturn;
	int                 nSize;
	SOCKET              nAcceptfd = NULL;
	fd_set              sListenSet;
	timeval             sTime;
  int                 nMemSize = 1024*10;
  HANDLE              hHandleIn;
  HANDLE              hHandleOut;
  bool                boOpt = TRUE;
  char                szInitBuffer[64];
  int                 nToSendInit;
  int                 nToSendInitPos;
  unsigned long       uArg;
	fd_set              sSelectSet;
	bool                gboConnected;
	int                 nSelectCycles;
  int                 nConnectCycles;

  if (gboListen != true)
  {
    return;
  }

  while (gboConnect)
  {
    gboListen = true;
    SetScreenText ("Initialising beacon", 0);

    nSockfdIn = socket (AF_INET, gnSockTypeIn, 0);
	  if (nSockfdIn == INVALID_SOCKET)
	  {
	    ShowError ();
      gboListen = false;
      SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
	  }
	  else
	  {
      // Set to non blocking
	    uArg = 1;
      ioctlsocket (nSockfdIn, FIONBIO , & uArg);

      setsockopt (nSockfdIn, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));
      SetScreenText ("Created beacon", 0);

      nSockfdOut = socket (AF_INET, gnSockTypeOut, 0);
	    if (nSockfdOut == INVALID_SOCKET)
	    {
  	    ShowError ();
  	    CloseSocket (nSockfdIn);
        gboListen = false;
	    }
	    else
	    {
        setsockopt (nSockfdOut, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));
        SetScreenText ("Creating bridge", 0);

	      sHostAddr.sin_family = AF_INET;
	      sHostAddr.sin_port = htons (gnPortIn);
        sHostAddr.sin_addr.s_addr = inet_addr (gszAddressIn);
	      memset (& (sHostAddr.sin_zero), '\0', 8);

        SetScreenText ("Beacon active", 0);
        gboConnected = false;
        nConnectCycles = 0;
        do
        {
  	      nReturn = connect (nSockfdIn, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
          // Wait for a bit
          if (nReturn == 0)
          {
            gboConnected = true;
          }

          if ((nReturn != 0) && ((WSAGetLastError () == WSAEINPROGRESS) || (WSAGetLastError () == WSAEWOULDBLOCK)))
          {
            nSelectCycles = 0;
            do
            {
						  FD_ZERO (& sSelectSet);
						  FD_SET (nSockfdIn, & sSelectSet);
						  sTime.tv_sec = SELECT_TIME_SECS;
						  sTime.tv_usec = SELECT_TIME_USECS;

              nReturn = select (nSockfdIn, NULL, & sSelectSet, NULL, & sTime);

              if (nReturn != -1)
              {
  						  if (FD_ISSET (nSockfdIn, & sSelectSet))
  						  {
  						    // Connected
  						    gboConnected = true;
  						  }
  					  }
  					  else
  					  {
  					    nReturn = WSAGetLastError ();
  					    gboListen = FALSE;
  					  }
              nSelectCycles++;
            } while (((!gboConnected) && (gboListen) && (gboConnect)) && (nSelectCycles < SELECT_CYCLES));
          }
        } while (((!gboConnected) && (gboListen) && (gboConnect)) && (nSelectCycles < CONNECT_CYCLES));

        if ((gboListen) && (gboConnect) && (gboConnected))
        {
          SetScreenText ("Semi connected", 1);
        }
        else
        {
	        CloseSocket (nSockfdOut);
	        CloseSocket (nSockfdIn);
          gboListen = false;
        }

        if ((gboListen) && (gboConnect) && (gboConnected))
        {
          // Set to blocking
	        uArg = 0;
          ioctlsocket (nSockfdIn, FIONBIO , & uArg);
        }

	      while ((gboListen) && (gboConnect) && (gboConnected))
	      {
          nToSendInit = 0;
	        nReturn = recv (nSockfdIn, szInitBuffer, sizeof (szInitBuffer), 0);

          if (nReturn < 0)
          {
            ShowError ();
          }
          if (nReturn <= 0)
          {
            // Connection closed
	          CloseSocket (nSockfdOut);
	          CloseSocket (nSockfdIn);
            gboListen = false;
          }
          if (nReturn > 0)
          {
            nToSendInit = nReturn;
            SetScreenText ("Connecting bridge", 1);

	          sHostAddr.sin_family = AF_INET;
	          sHostAddr.sin_port = htons (gnPortOut);
	          sHostAddr.sin_addr.s_addr = inet_addr (gszAddressOut);
	          memset (& (sHostAddr.sin_zero), '\0', 8);
            nReturn = connect (nSockfdOut, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
            if (nReturn != 0)
            {
              ShowError ();
	            CloseSocket (nSockfdOut);
	            CloseSocket (nSockfdIn);
              gboListen = false;
            }
            else
            {
              SetScreenText ("Bridge active", 1);

              // Forward on the initial data
              nToSendInitPos = 0;
              while ((nToSendInitPos < nToSendInit) && (gboConnect) && (gboListen))
              {
  	            nReturn = send (nSockfdOut, szInitBuffer + nToSendInitPos, nToSendInit - nToSendInitPos, 0);
                if (nReturn > 0)
                {
                  nToSendInitPos += nReturn;
                }
                if (nReturn <= 0)
                {
                  ShowError ();
                  nToSendInit = 0;
	                CloseSocket (nSockfdOut);
	                CloseSocket (nSockfdIn);
                  gboListen = false;
                }
              }

              if (gboListen)
              {
                gboClosed = false;

                gsSendRecIn.sReceive = nSockfdIn;
                gsSendRecIn.szReceiveAddr = gszAddressIn;
                gsSendRecIn.nReceivePort = gnPortIn;
                gsSendRecIn.sSend = nSockfdOut;
                gsSendRecIn.szSendAddr = gszAddressOut;
                gsSendRecIn.nSendPort = gnPortOut;

                hHandleIn = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) SendRecProc, (void*)(& gsSendRecIn), 0, NULL);

                gsSendRecOut.sReceive = nSockfdOut;
                gsSendRecOut.szReceiveAddr = gszAddressOut;
                gsSendRecOut.nReceivePort = gnPortOut;
                gsSendRecOut.sSend = nSockfdIn;
                gsSendRecOut.szSendAddr = gszAddressIn;
                gsSendRecOut.nSendPort = gnPortIn;

                hHandleOut = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) SendRecProc, (void*)(& gsSendRecOut), 0, NULL);

                gboListen = false;
              }
            }
		      }
	      }
	    }
	  }
    SetScreenText ("Beacon inactive", 0);
    SetScreenText ("Bridge inactive", 1);
	}

  gboListen = false;
}

void Connect (bool boConnect)
{
  if ((boConnect) && (!gboListen))
  {
    SetScreenText ("Starting connections", 0);
    gboListen = true;
    ghListenHandle = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) listenProc, 0, 0, NULL);
  }

  gboConnect = boConnect;
  SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboConnect);
}

void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick)
{
  HMENU hMenu;
  MENUITEMINFO sMenuItem;

  hMenu = GetMenu (hWnd);
  sMenuItem.cbSize = sizeof (MENUITEMINFO);

  sMenuItem.fMask = MIIM_STATE;
//      GetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
  if (boTick)
  {
    sMenuItem.fState = MFS_CHECKED;
  }
  else
  {
    sMenuItem.fState = MFS_UNCHECKED;
  }
  SetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
}

void SendRecProc (SendRec * psSendRec)
{
	int                 nStorePos;
  int                 nMemSize = 1024*10;
  char                pcMemory[1024*10];
  int                 nShiftPos;
  int                 boClosed;
  SendRec             sSendRec;
  int                 nReturn;
  int                 nError;
	struct sockaddr_in  sReceiveAddr;
	struct sockaddr_in  sSendAddr;
	int                 nLen;

  sSendRec = * psSendRec;

	sReceiveAddr.sin_family = AF_INET;
	sReceiveAddr.sin_port = htons (sSendRec.nReceivePort);
	sReceiveAddr.sin_addr.s_addr = inet_addr (sSendRec.szReceiveAddr);
	memset (& (sReceiveAddr.sin_zero), '\0', 8);

	sSendAddr.sin_family = AF_INET;
	sSendAddr.sin_port = htons (sSendRec.nSendPort);
	sSendAddr.sin_addr.s_addr = inet_addr (sSendRec.szSendAddr);
	memset (& (sSendAddr.sin_zero), '\0', 8);

	nStorePos = 0;

  SetScreenText ("Fully connected", 2);

  boClosed = false;
	do
	{
    // In
		if ((nMemSize - nStorePos) > 0)
		{
			// Receive some data
      nLen = sizeof (sockaddr);
  		nReturn = recvfrom (sSendRec.sReceive, (pcMemory + nStorePos), (nMemSize - nStorePos), 0, (sockaddr *)& sReceiveAddr, & nLen);
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
  	      nReturn = 0;
  	    }
			}
			if (nReturn == 0)
			{
  			boClosed = true;
			}
			if (nReturn > 0)
			{
				nStorePos += nReturn;
			}
  	}
  	
    while ((nStorePos > 0) && (nReturn > 0))
    {
			// Send some data
      nLen = sizeof (sockaddr);
			nReturn = sendto (sSendRec.sSend, pcMemory, nStorePos, 0, (sockaddr *)& sSendAddr, nLen);
			
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
  	      nReturn = 0;
  	    }
			}
			if (nReturn > 0)
			{
				// Shift data down
        for (nShiftPos = nReturn; nShiftPos < nStorePos; nShiftPos++)
        {
          pcMemory[nShiftPos - nReturn] = pcMemory[nShiftPos];
        }
				nStorePos -= nReturn;
			}
    }
	} while ((!boClosed) && (!gboClosed));

  SetScreenText ("Disconnected", 2);

  gboClosed = true;
	CloseSocket (sSendRec.sReceive);
	CloseSocket (sSendRec.sSend);

//  Connect (gboConnect);
}

void SetScreenText (char * szText, int nPos)
{
  strncpy (gszDisplay[nPos], szText, 1024);
	RedrawWindow(ghWnd, NULL, NULL, (RDW_INVALIDATE | RDW_ERASE));
}

void ShowError (void)
{
  char                szError[1024];

	sprintf (szError, "Socket error (%d)", WSAGetLastError ());
  MessageBox (NULL, szError, "Socket error", MB_OK);
  SetScreenText (szError, 3);
}

void CloseSocket (SOCKET nSocket)
{
  int   nReturn;
  char  szBuf[1024];

  shutdown (nSocket, SD_SEND);

  do
  {
    nReturn = recv (nSocket, szBuf, sizeof (szBuf), 0);
  } while (nReturn > 0);

  closesocket (nSocket);
}

