// SocketSwitch.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SocketSwitch.h"
#include "Winsock2.h"
#include "stdio.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
void Redraw (PAINTSTRUCT * psPaint, HDC sHDC);

typedef struct _SendRec SendRec;

struct _SendRec
{
  SOCKET    sSocket;
  SOCKET    sAcceptSocket;
  int       nPort;
  SendRec * psSendRec;
  int       nIcon;
};

static int          gboListen = false;
static int          gboConnect;
static int          gnPortIn = 6435;
static int          gnPortOut = 3389;
static HANDLE       ghListenHandleIn = 0;
static HANDLE       ghListenHandleOut = 0;
static HWND         ghWnd = 0;
static WSAData      gsWSAData;
static bool         gboClosed;
static SendRec      gsSendRecIn;
static SendRec      gsSendRecOut;
static char         gszDisplay[4][1024] = {"" ,"", "", ""};

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Details(HWND, UINT, WPARAM, LPARAM);
void listenProc (SendRec * psSendRec);
void Quit (void);
void Connect (bool boConnect);
void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick);
void SendRecProc (SendRec * psSendRec);
void ShowError (void);
void CloseSocket (SOCKET nSocket);
void SetScreenText (char * szText, int nPos);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
  int nArgPos;
  int nStartPos;
  int nCopyPos;
  char szInput[1024];
  int nArg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SOCKETSWITCH, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

  if (lpCmdLine)
  {
    nArg = 0;
    nArgPos = 0;
    while ((lpCmdLine[nArgPos] >= 32) && (nArg < 2))
    {
      // Remove any spaces
      while (lpCmdLine[nArgPos] == 32)
      {
        nArgPos++;
      }

      // First input Address in
      nStartPos = nArgPos;
      nCopyPos = 0;
      while (lpCmdLine[nArgPos] > 32)
      {
        if (nCopyPos < (sizeof (szInput) - 1))
        {
          szInput[nCopyPos] = lpCmdLine[nArgPos];
          nCopyPos++;
        }
        nArgPos++;
      }
      szInput[nCopyPos] = 0;

      switch (nArg)
      {
        case 0: // Port in
          sscanf (szInput, "%d", & gnPortOut);
          break;
        case 1: // Port out
          sscanf (szInput, "%d", & gnPortIn);
          break;
      }
      nArg++;
    }
  }

  gboListen = false;
  gboConnect = false;

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SOCKETSWITCH);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SOCKETSWITCH);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_SOCKETSWITCH;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  HWND hWnd;

  hInst = hInstance; // Store instance handle in our global variable

  hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, 0, 180, 180, NULL, NULL, hInstance, NULL);

  if (!hWnd)
  {
    return FALSE;
  }

  ghWnd = hWnd;
  if (WSAStartup (MAKEWORD (1, 1), & gsWSAData) != 0)
  {
  	MessageBox (ghWnd, "Error starting WinSock", "Socket error", MB_OK);
	  return 0;
  }

  Connect (gboConnect);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox (hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			Quit ();
			break;
	  case ID_CONNECT_CONNECT:
	    Connect (!gboConnect);
	    break;
	  case IDM_DETAILS:
			DialogBox (hInst, (LPCTSTR)IDD_DETAILS, hWnd, (DLGPROC)Details);
	    break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
    Redraw (& ps, hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
  	Quit ();
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

void Redraw (PAINTSTRUCT * psPaint, HDC sHDC)
{
	COLORREF        uPrevFore;
	COLORREF        uPrevBack;
	HFONT           sPrevFont;
	HFONT           sFont;
	LOGFONT         sFontInfo;

	uPrevFore = SetTextColor (sHDC, RGB(0x00, 0x00, 0x00));
	uPrevBack = SetBkColor (sHDC, RGB(0xff, 0xff, 0xff));

	memset (& sFontInfo, 0, sizeof (LOGFONT));
	sFontInfo.lfHeight = 16;
	strcpy (sFontInfo.lfFaceName, "Courier New");
	sFont = ::CreateFontIndirect (& sFontInfo);
	sPrevFont = (HFONT)::SelectObject (sHDC, sFont);

	// Font and colours set up, so now do the plotting

	SetTextColor (sHDC, RGB(0,0,0));
	ExtTextOut(sHDC, 5, 0, 0, NULL, gszDisplay[0], (int)strlen (gszDisplay[0]), NULL);
	ExtTextOut(sHDC, 5, 16, 0, NULL, gszDisplay[1], (int)strlen (gszDisplay[1]), NULL);
	ExtTextOut(sHDC, 5, 32, 0, NULL, gszDisplay[2], (int)strlen (gszDisplay[2]), NULL);
	ExtTextOut(sHDC, 5, 48, 0, NULL, gszDisplay[3], (int)strlen (gszDisplay[3]), NULL);

	::SelectObject (sHDC, sPrevFont);
	DeleteObject (sFont);
	SetTextColor (sHDC, uPrevFore);
	SetBkColor (sHDC, uPrevBack);
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// Message handler for details box.
LRESULT CALLBACK Details(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  char szText[1024];
	HWND hCombo;
	HWND hItem;
  int nSel;

	switch (message)
	{
	case WM_INITDIALOG:
    sprintf (szText, "%d", gnPortOut);
    SetDlgItemText (hDlg, IDC_SENDPORT, szText);

    sprintf (szText, "%d", gnPortIn);
    SetDlgItemText (hDlg, IDC_RECEIVEPORT, szText);
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK)
		{
		  GetDlgItemText (hDlg, IDC_SENDPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortOut);

		  GetDlgItemText (hDlg, IDC_RECEIVEPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortIn);
		}

		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}

		break;
	}
	return FALSE;
}

void Quit (void)
{
	WSACleanup();
}

void listenProc (SendRec * psSendRec)
{
	SOCKET              nSockfdIn;
	SOCKET              nSockfdOut;
	struct sockaddr_in  sHostAddr;
	struct sockaddr_in  sClientAddr;
	int                 nReturn;
	int                 nSize;
	SOCKET              nAcceptfd = NULL;
	fd_set              sListenSet;
	timeval             sTime;
  int                 nMemSize = 1024*10;
  char                szError[1024];
  HANDLE              hHandleIn;
  HANDLE              hHandleOut;
  bool                boAccept;
  bool                boOpt = TRUE;

  SetScreenText ("", psSendRec->nIcon);
  SetScreenText ("Disconnected", psSendRec->nIcon + 1);

	if (gboListen != true)
  {
    return;
  }

  psSendRec->sSocket = socket (AF_INET, SOCK_STREAM, 0);
	if (psSendRec->sSocket == INVALID_SOCKET)
	{
	  ShowError ();
	}
	else
	{
    setsockopt (psSendRec->sSocket, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));

	  sHostAddr.sin_family = AF_INET;
	  sHostAddr.sin_port = htons (psSendRec->nPort);
    sHostAddr.sin_addr.s_addr = htonl (INADDR_ANY);
	  memset (& (sHostAddr.sin_zero), '\0', 8);

  	nReturn = bind (psSendRec->sSocket, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
    if (nReturn != 0)
    {
      ShowError ();
      CloseSocket (psSendRec->sSocket);
      psSendRec->sSocket = INVALID_SOCKET;
      gboListen = false;
      gboConnect = false;
      SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
    }
    else
    {
	    nReturn = listen (psSendRec->sSocket, 10);
      if (nReturn != 0)
      {
        ShowError ();
        CloseSocket (psSendRec->sSocket);
        psSendRec->sSocket = INVALID_SOCKET;
        gboListen = false;
        gboConnect = false;
        SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
      }
      else
      {
        SetScreenText ("Listening", psSendRec->nIcon + 1);
	      while ((gboListen) && (gboConnect))
	      {
  	      boAccept = false;
		      FD_ZERO (& sListenSet);
		      FD_SET (psSendRec->sSocket, & sListenSet);
		      sTime.tv_sec = 0;
		      sTime.tv_usec = 100000;
		      nReturn = select ((int)psSendRec->sSocket + 1, & sListenSet, NULL, NULL, & sTime);
		      if (nReturn != -1)
		      {
			      if (FD_ISSET (psSendRec->sSocket, & sListenSet))
			      {
				      // Need to forward any data received
				      nSize = sizeof (struct sockaddr_in);
				      nAcceptfd = accept (psSendRec->sSocket, (struct sockaddr *)& sClientAddr, & nSize);
              SetScreenText (inet_ntoa (sClientAddr.sin_addr), psSendRec->nIcon);
              boAccept = true;
            }
          }
		      else
		      {
		        ShowError ();
            gboListen = false;
		      }

          if (boAccept)
          {
            SetScreenText ("Accepted", psSendRec->nIcon + 1);
            gboClosed = false;
            CloseSocket (psSendRec->sSocket);
            psSendRec->sSocket = INVALID_SOCKET;
            psSendRec->sAcceptSocket = nAcceptfd;
            SendRecProc (psSendRec);
            gboListen = false;
		      }
	      }
	    }
    }
  }

  SetScreenText ("Disconnected", psSendRec->nIcon + 1);
  SetScreenText ("", psSendRec->nIcon);
  CloseSocket (psSendRec->sSocket);
  psSendRec->sSocket = INVALID_SOCKET;
  gboListen = false;
  gboConnect = false;
  SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
}

void Connect (bool boConnect)
{
  if ((boConnect) && (!gboListen))
  {
    gboListen = true;
    gsSendRecIn.nPort = gnPortIn;
    gsSendRecIn.sSocket = INVALID_SOCKET;
    gsSendRecIn.sAcceptSocket = INVALID_SOCKET;
    gsSendRecIn.psSendRec = & gsSendRecOut;
    gsSendRecIn.nIcon = 0;

    gsSendRecOut.nPort = gnPortOut;
    gsSendRecOut.sSocket = INVALID_SOCKET;
    gsSendRecOut.sAcceptSocket = INVALID_SOCKET;
    gsSendRecOut.psSendRec = & gsSendRecIn;
    gsSendRecOut.nIcon = 2;

    ghListenHandleIn = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) listenProc, (void*)(& gsSendRecIn), 0, NULL);
    ghListenHandleOut = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) listenProc, (void*)(& gsSendRecOut), 0, NULL);
  }

  gboConnect = boConnect;
  SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboConnect);
}

void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick)
{
  HMENU hMenu;
  MENUITEMINFO sMenuItem;

  hMenu = GetMenu (hWnd);
  sMenuItem.cbSize = sizeof (MENUITEMINFO);

  sMenuItem.fMask = MIIM_STATE;
//      GetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
  if (boTick)
  {
    sMenuItem.fState = MFS_CHECKED;
  }
  else
  {
    sMenuItem.fState = MFS_UNCHECKED;
  }
  SetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
}

void SendRecProc (SendRec * psSendRec)
{
	int                 nStorePos;
  int                 nMemSize = 1024*10;
  char                pcMemory[1024*10];
  char                szError[1024];
  int                 nShiftPos;
  int                 boClosed;
  int                 nReturn;
  int                 nError;

	nStorePos = 0;

  SetScreenText ("Connected", psSendRec->nIcon + 1);
  boClosed = false;
	do
	{
    // In
		if ((nMemSize - nStorePos) > 0)
		{
			// Receive some data
      nReturn = recv (psSendRec->sAcceptSocket, (pcMemory + nStorePos), (nMemSize - nStorePos), 0);
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
			    ShowError ();
  	      nReturn = 0;
  	    }
			}
			if (nReturn == 0)
			{
  			boClosed = true;
			}
			if (nReturn > 0)
			{
				nStorePos += nReturn;
			}
  	}
  	
    while ((nStorePos > 0) && (nReturn > 0) && (psSendRec->psSendRec->sAcceptSocket != INVALID_SOCKET))
    {
			// Send some data
      nReturn = send (psSendRec->psSendRec->sAcceptSocket, pcMemory, nStorePos, 0);
			
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
			    ShowError ();
  	      nReturn = 0;
  	    }
			}
			if (nReturn > 0)
			{
				// Shift data down
        for (nShiftPos = nReturn; nShiftPos < nStorePos; nShiftPos++)
        {
          pcMemory[nShiftPos - nReturn] = pcMemory[nShiftPos];
        }
				nStorePos -= nReturn;
			}
    }
	} while ((!boClosed) && (!gboClosed));

  gboClosed = true;
  CloseSocket (psSendRec->sAcceptSocket);
  psSendRec->sAcceptSocket = INVALID_SOCKET;
}

void ShowError (void)
{
  char                szError[1024];

	sprintf (szError, "Socket error (%d)", WSAGetLastError ());
  MessageBox (NULL, szError, "Socket error", MB_OK);
}

void CloseSocket (SOCKET nSocket)
{
  int   nReturn;
  char  szBuf[1024];

  if (nSocket != INVALID_SOCKET)
  {
    shutdown (nSocket, SD_SEND);

    do
    {
      nReturn = recv (nSocket, szBuf, sizeof (szBuf), 0);
    } while (nReturn > 0);

    closesocket (nSocket);
  }
}

void SetScreenText (char * szText, int nPos)
{
  strncpy (gszDisplay[nPos], szText, 1024);
	RedrawWindow(ghWnd, NULL, NULL, (RDW_INVALIDATE | RDW_ERASE));
}
